// Code generated by "enumer -type=SyncActionType -json -text -yaml -sql"; DO NOT EDIT.

//
package synchActionTypes

import (
	"database/sql/driver"
	"encoding/json"
	"fmt"
)

const _SyncActionTypeName = "UnknownCleanCommitExportFetchResetHardStatusImportPullPushRemoveRepoFilesRemoveDbDir"

var _SyncActionTypeIndex = [...]uint8{0, 7, 12, 18, 24, 29, 38, 44, 50, 54, 58, 73, 84}

func (i SyncActionType) String() string {
	if i < 0 || i >= SyncActionType(len(_SyncActionTypeIndex)-1) {
		return fmt.Sprintf("SyncActionType(%d)", i)
	}
	return _SyncActionTypeName[_SyncActionTypeIndex[i]:_SyncActionTypeIndex[i+1]]
}

var _SyncActionTypeValues = []SyncActionType{0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11}

var _SyncActionTypeNameToValueMap = map[string]SyncActionType{
	_SyncActionTypeName[0:7]:   0,
	_SyncActionTypeName[7:12]:  1,
	_SyncActionTypeName[12:18]: 2,
	_SyncActionTypeName[18:24]: 3,
	_SyncActionTypeName[24:29]: 4,
	_SyncActionTypeName[29:38]: 5,
	_SyncActionTypeName[38:44]: 6,
	_SyncActionTypeName[44:50]: 7,
	_SyncActionTypeName[50:54]: 8,
	_SyncActionTypeName[54:58]: 9,
	_SyncActionTypeName[58:73]: 10,
	_SyncActionTypeName[73:84]: 11,
}

// SyncActionTypeString retrieves an enum value from the enum constants string name.
// Throws an error if the param is not part of the enum.
func SyncActionTypeString(s string) (SyncActionType, error) {
	if val, ok := _SyncActionTypeNameToValueMap[s]; ok {
		return val, nil
	}
	return 0, fmt.Errorf("%s does not belong to SyncActionType values", s)
}

// SyncActionTypeValues returns all values of the enum
func SyncActionTypeValues() []SyncActionType {
	return _SyncActionTypeValues
}

// IsASyncActionType returns "true" if the value is listed in the enum definition. "false" otherwise
func (i SyncActionType) IsASyncActionType() bool {
	for _, v := range _SyncActionTypeValues {
		if i == v {
			return true
		}
	}
	return false
}

// MarshalJSON implements the json.Marshaler interface for SyncActionType
func (i SyncActionType) MarshalJSON() ([]byte, error) {
	return json.Marshal(i.String())
}

// UnmarshalJSON implements the json.Unmarshaler interface for SyncActionType
func (i *SyncActionType) UnmarshalJSON(data []byte) error {
	var s string
	if err := json.Unmarshal(data, &s); err != nil {
		return fmt.Errorf("SyncActionType should be a string, got %s", data)
	}

	var err error
	*i, err = SyncActionTypeString(s)
	return err
}

// MarshalText implements the encoding.TextMarshaler interface for SyncActionType
func (i SyncActionType) MarshalText() ([]byte, error) {
	return []byte(i.String()), nil
}

// UnmarshalText implements the encoding.TextUnmarshaler interface for SyncActionType
func (i *SyncActionType) UnmarshalText(text []byte) error {
	var err error
	*i, err = SyncActionTypeString(string(text))
	return err
}

// MarshalYAML implements a YAML Marshaler for SyncActionType
func (i SyncActionType) MarshalYAML() (interface{}, error) {
	return i.String(), nil
}

// UnmarshalYAML implements a YAML Unmarshaler for SyncActionType
func (i *SyncActionType) UnmarshalYAML(unmarshal func(interface{}) error) error {
	var s string
	if err := unmarshal(&s); err != nil {
		return err
	}

	var err error
	*i, err = SyncActionTypeString(s)
	return err
}

func (i SyncActionType) Value() (driver.Value, error) {
	return i.String(), nil
}

func (i *SyncActionType) Scan(value interface{}) error {
	if value == nil {
		return nil
	}

	str, ok := value.(string)
	if !ok {
		bytes, ok := value.([]byte)
		if !ok {
			return fmt.Errorf("value is not a byte slice")
		}

		str = string(bytes[:])
	}

	val, err := SyncActionTypeString(str)
	if err != nil {
		return err
	}

	*i = val
	return nil
}
